#include "stdafx.h"
#include "CCell.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CCell::CCell ()
{
	Word = "";
	NumberOfWord = NullWord;	
	Type = Vertical;
	X = 0;
	Y = 0;
	Length = 0;
	CrossList = NULL;
	CrossCounter = 0;
}

CCell::CCell (const CCell& c)
{
	CrossList = new CrossStruct [c.Length];
	if (CrossList != NULL)
	{
		CrossCounter = c.CrossCounter;
		Word = c.Word;
		NumberOfWord = c.NumberOfWord;
		Type = c.Type;
		X = c.X;
		Y = c.Y;
		Length = c.Length;
		for (int i = 0; i < Length; i++)
		{
			CrossList [i].CellNumber = c.CrossList [i].CellNumber;
			CrossList [i].CharNumber = c.CrossList [i].CharNumber;
		}
	}
}

CCell::~CCell ()
{
	DeleteContent ();
}

void CCell::DeleteContent (void)
{
	if (CrossList != NULL)
	{
		delete CrossList;
		CrossList = NULL;
	}
	
	Word = "";
	NumberOfWord = NullWord;	
	Type = Vertical;
	X = 0;
	Y = 0;
	Length = 0;
	CrossCounter = 0;
}

const CCell& CCell::operator= (const CCell& c)
{
	DeleteContent ();
	
	CrossList = new CrossStruct [c.Length];
	if (CrossList != NULL)
	{
		CrossCounter = c.CrossCounter;
		Word = c.Word;
		NumberOfWord = c.NumberOfWord;	
		Type = c.Type;
		X = c.X;
		Y = c.Y;
		Length = c.Length;
		for (int i = 0; i < Length; i++)
		{
			CrossList [i].CellNumber = c.CrossList [i].CellNumber;
			CrossList [i].CharNumber = c.CrossList [i].CharNumber;
		}
	}

	return *this;
}

void CCell::Set (int newType, int newX, int newY, int newLength, LPCTSTR newWord)
{
	DeleteContent ();
	
	CrossList = new CrossStruct [newLength];
	if (CrossList != NULL)
	{
		Word = newWord;
		NumberOfWord = NullWord;
		Type = newType;
		X = newX;
		Y = newY;
		Length = newLength;
		ClearCrossList ();
	}
}

void CCell::ClearCrossList (void)
{
	if (CrossList == NULL)
		return;
	for (int i = 0; i < Length; i++)
	{
		CrossList [i].CellNumber = NullCell;
		CrossList [i].CharNumber = 0;
	}
	CrossCounter = 0;
}
