// CrossMasterDoc.h : interface of the CCrossMasterDoc class
//
/////////////////////////////////////////////////////////////////////////////

#include "CCrossword.h"

#define CellSize	18

typedef struct 
{
	long id;
	CString name;
} TypeStruct;

class CCrossMasterDoc : public CDocument
{
protected: // create from serialization only
	CCrossMasterDoc();
	DECLARE_DYNCREATE(CCrossMasterDoc)

// Attributes
public:
	CCrossMasterApp*	m_pApp;		//    

	CDaoDatabase m_Database;		// 
	
	CString	m_strDatabaseName;		//  : Words.mdb

	CString	m_strWordsTableName;	//  : WORDS
	CString	m_strWordsColumnName;	//  : WORD
	CString	m_strWordKeysColumnName;//  : WORD_KEY
	CString	m_strQuestionColumnName;//  : QUESTION

	CString	m_strTypesTableName;	//  : TYPES
	CString	m_strTypesColumnName;	//  : TYPE
	CString	m_strTypeKeysColumnName;//  : TYPE_KEY

	BOOL m_bDictionaryLoaded;	//    
	long m_nDictionaryCount;	//    
	
	TypeStruct* m_dimTypes;	//     TYPES
	long m_nTypesCount;		//   
	long m_nTypeSelect;		//    (  m_dimTypes)

	CCrossword Crossword;		//   

	BOOL m_bBuildResult;		//   
	BOOL m_bBuildInProgress;	//    
	BOOL m_bTerminateRequest;	//     

	BOOL m_bEnableDrawCell;		//      

// Operations
public:
	BOOL OpenDatabase (void);	//   
	void CloseDatabase (void);	//   

	//     
	BOOL OpenRecordset (CDaoRecordset &Recordset, CString strQuery, long &count);

	void ReportDaoError (CDaoException* e);

	BOOL LoadTypes (void);		//      
	void DeleteTypes (void);

	BOOL LoadDictionary (void);	//    

	void ReportStatus (void);	//    

	//   
	BOOL BuildCrossword (CDaoRecordset& FindRecordset); // 
	long FindWordForCell (CDaoRecordset& FindRecordset,
		long CellNumber, long WordNumber); //  

	void DrawCell (long index, CDC *pDC = NULL); //  

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCrossMasterDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCrossMasterDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCrossMasterDoc)
	afx_msg void OnSelchangeWordsList();
	afx_msg void OnSelchangeTypesList();
	afx_msg void OnCrosswordStart();
	afx_msg void OnCrosswordStop();
	afx_msg void OnUpdateCrosswordStart(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCrosswordStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppExit(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileMruFile1(CCmdUI* pCmdUI);
	afx_msg void OnFileAccess();
	afx_msg void OnUpdateFileAccess(CCmdUI* pCmdUI);
	afx_msg void OnViewCell();
	afx_msg void OnUpdateViewCell(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
